
var developerAuth = 'Bearer '+context.getVariable("access_token");

var env = context.getVariable("environment.name");

var BUName = getBUName(context.getVariable("request.header.X-OUID"));

if(BUName != null)
	context.setVariable("myBUName", BUName);
  else
    context.setVariable("myBUName", context.getVariable("request.header.X-OUID"));
  
var paths = [
             "/v1/audience/lock/{deploymentId}",
             "/v1/contentMaps/{id}","v1/contentMaps/{id}/contentRules"," /v1/contentMaps/{id}/contentRules/{cRuleId}",
             "/v1/conversionSettings/{id}",
             "/v1/messages/deployment/tag/search", "/v1/messages/{messageID}/deployment", "/v1/messages/{messageID}/deployment/{deploymentID}/status","/v1/messages/{messageID}/deployment/{deploymentID}"," /v1/messages/{messageID}/deployment/{deploymentID}/cancel","/v1/messages/{messageID}/deployment/{deploymentID}/pause"," /v1/messages/{messageID}/deployment/{deploymentID}/resume","/v1/messages/{messageID}/deployment/{deploymentID}/trackedAttributes",
             "/v4/files/{fileNameOrId}",
             "/v1/file-transfers/{transferId}/status","/v1/file-transfers/{transferId}/cancel","/v1/file-transfers/{transferId}",
             "/v1/folder-items/{id}/archive",
             "/v1/listImports/dataFiles/{matchString:.*}","/v1/listImports/mapping/{listId}/{fileId}","/v1/listImports/referenceTableMapping/{tableId}/{fileId}",
             "/public/v1/lists/{id}/data","/public/v1/lists/{id}/data/{customerKey:.+}",
             "/v4/imports/{persistentMappingIDorName}","/v4/imports/resetDeliveryStatistics/{sourceFile}","/v4/persistentMappings{idOrName}","/v4/jobStatus/{id}",
             "/v1/jobMonitor/{jobId}",
             "/v1/jobStatus/{jobId}","/v1/jobStatus/id/{statusId}","/v1/jobStatus/user/{userName}","/v1/jobStatus/list/{listId}",
             "/v1/jobs/status/{jobId}",
             "/v1/joins/{id}",
             "/v2/lists/{listId}","/v2/lists/{listId}/copy","/v2/lists/{listId}/exports","v2/lists/{sourceId}/split","/v2/lists/{listId}/data","/v2/lists/{listId}/getdata","/v2/lists/{listId}/data/{recordID}","/v2/lists/{listId}/imports","v2/lists/{listId}/imports/mappings/{fileId}","/v2/lists/imports/mappings/{fileId}","/v2/lists/{listId}/imports/persistentMappings","/v2/lists/{listId}/imports/persistentMappings/{mappingId}"," /v2/lists/{listId}/link","/v2/lists/{listId}/unlink","/v2/lists/{listId}/exports/count","/v2/lists/{listId}/exports/validate","/v2/lists/{listId}/status"," /v2/lists/{listId}/status/{status}",
             "/v3/lists/{id}/split","/v3/lists/{id}/attributes/analysis",
             "/v4/lists/{id}","/v4/lists/{listId}/records","/v4/lists/{listId}/records/{customerKey:.+}","/v4/lists/{listId}/records/search",
             "/v1/messages/{id}/proof/audienceTable","/v1/messages/{id}","/v1/messages/{id}/activate/lite","/v1/messages/{id}/schedule","/v1/messages/{id}/proof"," /v1/messages/{id}/audience/count",
             "/v1/messages/mobilePush/simple/{id}","/v1/messages/mobilePush/simple/{mobilePushMessageId}/schedule","/v1/messages/mobilePush/simple/{id}/validate","/v1/messages/mobilePush/simple/deploy/{deploymentId}","/v1/messages/mobilePush/simple/{id}/validateAndActivate","/v1/messages/mobilePush/simple/cancel/{deploymentId}","/v1/messages/mobilePush/simple/{id}/activate","/v1/messages/mobilePush/simple/{id}/deactivate",
             "/v1/mobilePushApps/{mobilePushAppId}","/v1/mobilePushApps/{mobilePushAppId}/mapto/{mobilePushSubscriptionListId}",
             "/v2/profiles/{profileId}"," /v2/profiles/{profileId}/subscriptions","v2/profiles/{profileId}/subscriptions/{profileSubId}","/v2/profiles/imports/mappings/{fileId}","/v2/profiles/imports/persistentMappings/{mappingId}","/v2/profiles/{profileId}/optOut",
             "/v4/profiles/attributes/{attributeId}","/v4/profiles/records/{customerKey:.+}","/v4/profiles/records/{customerKey:.+}/optOut","/v4/profiles/records/{customerKey:.+}/optOut/{channelName}","/v4/profiles/records/{customerKey}/emailAddress"," /v4/profiles/records/{customerKey}/emailAddress/{emailAddress:.+}","/v4/profiles/records/{customerKey}/emailAddress/{emailAddress:.+}/ftds/reset","/v4/profiles/records/{customerKey}/smsNumber","/v4/profiles/records/{customerKey}/smsNumber/{smsNumber:.+}",
             "/v1/referenceTables/{tableId}"," /v1/referenceTables/{tableId}/data","/v1/referenceTables/{tableId}/getdata"," /v1/referenceTables/{tableId}/data/{dataId}","/v1/referenceTables/{tableId}/imports","/v1/referenceTables/{tableId}/imports/mappings/{fileId}","/v1/referenceTables/imports/mappings/{fileId}","/v1/referenceTables/{tableId}/imports/persistentMappings","/v1/referenceTables/{tableId}/imports/persistentMappings/{mappingId}","/v1/referenceTables/{tableId}/exports","/v1/referenceTables/{tableId}/exports/count","/v1/referenceTables/{tableId}/attributes/analysis",
             "/v4/referenceTables/{id}","/v4/referenceTables/{tableId}/data","/v4/referenceTables/{referenceTableId}/records","/v4/referenceTables/{referenceTableId}/records/{recordId:.+}","/v4/referenceTables/{referenceTableId}/records/search",
             "/public/v1/activities/download/{orgUnitId}","/v1/reports/workflowData/{orgId}","/v1/reports/reportSnapshot/{orgId}/{deploymentId}","/v1/reports/allDeploymentMetricsAggregatesForGivenFilterCriteria/{orgId}",
             "/v1/messages/sms/broadcast/{smsMessageId}","/v1/messages/sms/broadcast/{smsMessageId}/schedule","/v1/messages/sms/broadcast/{smsMessageId}/activate","/v1/messages/sms/broadcast/{smsMessageId}/deactivate",
             "/v1/smsPrograms/{smsProgramId}","/v1/smsPrograms/{smsProgramId}/mapto/{listId}",
             "/v2/segmentation-rules/{id}","/v2/segmentation-rules/{id}/list","/v2/segmentation-rules/{id}/count",
             "/v1/server-connections/{id}",
             "/v4/subscriptions/{id}","/v4/subscriptions/{subId}/records","/v4/subscriptions/{subId}/records/{customerKey:.+}",
             "v1/admin/throttleGroups/{throttleGroupId}","v1/admin/throttleGroups/orgUnit/{orgUnitID}",
             "/v1/transactionTables/{tableId}","/v1/transactionTables/{tableId}/jobs/search","/v1/transactionTables/{tableId}/getdata"," /v1/transactionTables/{tableId}/column/{columnId}","/v1/transactionTables/{tableId}/data","/v1/transactionTables/{tableId}/column","/v1/transactionTables/{tableId}/data/{dataId}","/v1/transactionTables/{tableId}/link","/v1/transactionTables/imports/mappings/{fileId}","/v1/transactionTables/{tableId}/unlink"," /v1/transactionTables/{tableId}/imports/mappings/{fileId}","/v1/transactionTables/{tableId}/exports","/v1/transactionTables/{tableId}/imports","/v1/transactionTables/{tableId}/imports/persistentMappings","/v1/transactionTables/{tableId}/imports/persistentMappings/{mappingId}","/v1/transactionTables/{tableId}/exports/count",
             "v4/transactionTables/{transactionTableID}","/v4/transactionTables/{id}","/v4/transactionTables/{tableId}/records/search",
             "/v1/workflowdeployments/{id}",
             "/v2/messages/{id}/send","/v3/messages/{id}/send",
             ];

var pathsuffix = getOriginalPathSuffix(context.getVariable("proxy.pathsuffix"));

context.setVariable("myPathSuffix", pathsuffix);


function getOriginalPathSuffix(pathsuffix){
  var newpathsuffix = pathsuffix;
  for(var i=0;i<paths.length;i++)
  {

    if(MatchesPath(pathsuffix , paths[i])) {
      
       newpathsuffix = paths[i];
       break;
    }
  }
  return newpathsuffix;
}


       
function MatchesPath(path1, path2){
      
      var path1tokens = path1.split('/');
      var path2tokens = path2.split('/');
      
     
      if(path1tokens.length == path2tokens.length){
        var path = '';
        for(var i=1;i<path1tokens.length;i++){
          	if(path1tokens[i] == path2tokens[i])
            	path += '/'+path1tokens[i];   	
          else {
            if(path2tokens[i][0] == '{')
                path += '/'+path2tokens[i]; 
            else
                path += '/'+path1tokens[i]; 
          }
        }
        
        if(path == path2) 
          	return true
           else
             return false;
      } else {  //if number of tokens in path1 and path2 are not equal then it is not a match.
        return false;
      }
}


function getBUName(xouid){
   var OrgName = null;
   var OrgInfo = context.getVariable("myOrgUnit");
  if(OrgInfo == null ){
 	OrgName =  getDeveloperOrgUnitNameHarmony(xouid);
    context.setVariable("setOrgInfo","TRUE");
    context.setVariable("newOrgInfo", OrgName+";");
  }
  else {
    OrgName = OrgInfo.split(';')[0];
    context.setVariable("setOrgInfo","FALSE");
  }

}

function getDeveloperOrgUnitNameHarmony(xouid) {
  
  var getDeveloperOrgUnitNameHarmonyURL = '';

	if(env == "test")
      	getDeveloperOrgUnitNameHarmonyURL = 'https://stagingapi-internal.harmony.epsilon.com/v1/org-units/'+ xouid;
    else
        getDeveloperOrgUnitNameHarmonyURL = 'https://api-internal.harmony.epsilon.com/v1/org-units/'+ xouid;
  
  var OrgUnitName = '';
   
  var headers = {'Authorization':developerAuth,'Content-Type':'application/json'};

  var req = new Request(getDeveloperOrgUnitNameHarmonyURL, 'GET', headers);
  var exchange = httpClient.send(req);

  // Wait for the asynchronous POST request to finish
  exchange.waitForComplete();

  if (exchange.isSuccess()) {
    var responseObj = exchange.getResponse().content.asJSON;

    if (responseObj.error) {
      throw new Error(responseObj.error_description);
    }
    
    //Extract DeveloperOrg Units
 
      OrgUnitName =responseObj.data.name;

    
  } else if (exchange.isError()) {
    throw new Error(exchange.getError());
  }
  
  return OrgUnitName;
}